<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
$usuarionube = "ingetronik";
$contrasenanube = "electronica";  // en mi caso tengo contrase�a pero en casa caso introducidla aqu�.
$servidornube = "165.227.112.149";
$basededatosnube = "magisoftv1portallocalnubegeneral";
include 'conexion.php';

//Se necesitan para bajar la informacion correctamente.
$empresaIdGlobal = 1;
$sedeIdGlobal = 1;

$conexionnube = mysqli_connect($servidornube, $usuarionube, $contrasenanube) or die("No se ha podido conectar al servidornube de Base de datos");
$db = mysqli_select_db($conexionnube, $basededatosnube) or die("Upps! Pues va a ser que no se ha podido conectar a la base de datos");
$conn = new mysqli($servidornube, $usuarionube, $contrasenanube, $basededatosnube);
mysqli_set_charset($conexionnube, 'utf8');

function DevolverUnDatoNube($query)
{
    global $conexionnube;
    $resultado = mysqli_query($conexionnube, $query) or die("Algo ha ido mal en la consulta a la base de datos");
    $arreglo = mysqli_fetch_array($resultado);
    if (mysqli_num_rows($resultado) > 0) {
        return $arreglo[0];
    } else {
        return array();
    }
}

function DevolverUnDato2Nube($query)
{
    global $conexionnube;
    $resultado = mysqli_query($conexionnube, $query) or die("Algo ha ido mal en la consulta a la base de datos");
    $arreglo = mysqli_fetch_array($resultado);
    if (mysqli_num_rows($resultado) > 0) {
        return array(
            0 => $arreglo[0]
        );
    } else {
        return array();
    }
}

function DevolverUnArregloNube($query)
{
    global $conexionnube;
    $resultado = mysqli_query($conexionnube, $query) or die("Algo ha ido mal en la consulta a la base de datos");
    $rawdata = array();
    while ($row = mysqli_fetch_assoc($resultado)) {
        $rawdata[] = $row;
    }
    return $rawdata;
}

function InsertDevolviendoIDNube($query)
{
    global $conexionnube;
    mysqli_query($conexionnube, $query);
    $resultado = mysqli_insert_id($conexionnube) or die("Algo ha ido mal en la consulta a la base de datos");
    return $resultado;
}

function hacerConsultaNube($query)
{
    global $conexionnube;
    $otra = mysqli_query($conexionnube, $query);
    return $otra;
}

// $usuarioAgenda = "ingetronik";
// $contrasenaAgenda = "electronica";  // en mi caso tengo contraseña pero en casa caso de que no introducidla aquí.
// $servidorAgenda = "157.230.11.245";
// $basededatosAgenda = "agendamientomedico";

// $conexionAgenda = mysqli_connect($servidorAgenda, $usuarioAgenda, $contrasenaAgenda) or die("No se ha podido conectar al servidorAgenda de Base de datos");
// $db = mysqli_select_db($conexionAgenda, $basededatosAgenda) or die("Upps! Pues va a ser que no se ha podido conectar a la base de datos");
// $conn = new mysqli($servidorAgenda, $usuarioAgenda, $contrasenaAgenda, $basededatosAgenda);
// mysqli_set_charset($conexionAgenda, 'utf8');

// function DevolverUnDatoAgenda($query)
// {
//     global $conexionAgenda;
//     $resultado = mysqli_query($conexionAgenda, $query) or die("Algo ha ido mal en la consulta a la base de datos");
//     $dato = '';
//     if (mysqli_num_rows($resultado) > 0) {
//         $arreglo = mysqli_fetch_array($resultado);
//         $dato = $arreglo[0];
//     }
//     return $dato;
// }

// function DevolverUnArregloAgenda($query)
// {
//     global $conexionAgenda;
//     $resultado = mysqli_query($conexionAgenda, $query) or die("Algo ha ido mal en la consulta a la base de datos");
//     $rawdata = array();
//     while ($row = mysqli_fetch_assoc($resultado)) {
//         $rawdata[] = $row;
//     }
//     return $rawdata;
// }

// function InsertDevolviendoIDAgenda($query)
// {
//     global $conexionAgenda;
//     mysqli_query($conexionAgenda, $query);
//     $resultado = mysqli_insert_id($conexionAgenda) or die("Algo ha ido mal en la consulta a la base de datos");
//     return $resultado;
// }

// function hacerConsultaAgenda($query)
// {
//     global $conexionAgenda;
//     $otra = mysqli_query($conexionAgenda, $query);
//     return $otra;
// }

//nube
sincronizarServiciosNube(); //▼
sincronizarUsuariosNube(); //▼
//sincronizarModuloNube(); //X
sincronizarpreguntasNube(); //▼
sincronizarRelacionUsuSerNube(); //▼
sincronizarPacientesNube(); //▼
sincronizarEspecialidadNube(); //▼
sincronizarRelaServiciosNube(); //▼
sincronizarHorarioAgendaNube();  //X
sincronizarTurnoAgendadoNube(); //▼
// reportarInternetSede();

/////////////////

//local
sincronizarServicios(); //▼
sincronizarUsuarios(); //▼
sincronizarAuditoria(); //▼
sincronizarCalificacion(); //▼
sincronizarRelacionUsuSer(); //▼
sincronizarpreguntas(); //▼
sincronizarModulo(); //▼
sincronizarPacientes(); //▼
sincronizarRelaServicios(); //▼
sincronizarEspecialidad(); //▼
sincronizarHorariosAgenda();
sincronizarTvs(); //▼

function reportarInternetSede()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $validar = hacerConsultaAgenda("update sedes set FechaValitSede = (SELECT NOW()) where ID = $sedeIdGlobal and emp_id = $empresaIdGlobal ");
}

function sincronizarServicios()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayServicios = DevolverUnArreglo("SELECT * FROM servicio WHERE EstadoNube = 0 AND IdSede = '$sedeIdGlobal' 
    AND emp_id = '$empresaIdGlobal'");
    foreach ($arrayServicios as $key) {
        $IdServicio = $key['IdServicio'];
        $Servicio = $key['Servicio'];
        $Prefijo = $key['Prefijo'];
        $Cont_min = $key['Cont_min'];
        $Cont_max = $key['Cont_max'];
        $Secuencia = $key['Secuencia'];
        $Prioridad = $key['Prioridad'];
        $LlamadoTv = $key['LlamadoTv'];
        $Eliminado = $key['Eliminado'];
        $EstadoSub = $key['EstadoSub'];
        $atril = $key['atril'];
        $VisibleDispe = $key['VisibleDispe'];
        $tiempoMax = $key['tiempoMax'];
        $HoraInicio = $key['HoraInicio'];
        $HoraFin = $key['HoraFin'];
        $atencioncita = $key['atencioncita'];
        $entrega = $key['entrega'];
        $control_limite = $key['control_limite'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayServiciosNube = DevolverUnArregloNube("SELECT * FROM servicio WHERE IdServicio = $IdServicio AND 
        IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayServiciosNube) {
            hacerConsultaNube("DELETE FROM servicio WHERE IdServicio = $IdServicio AND IdSede = $IdSede AND 
            emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO servicio 
        (IdServicio,Servicio,Prefijo,Cont_min,Cont_max,Secuencia,Prioridad,
        LlamadoTv,Eliminado,EstadoSub,atril,VisibleDispe,tiempoMax,HoraInicio,
        HoraFin,atencioncita,entrega,IdSede,emp_id,EstadoNube)
        VALUES
        ($IdServicio,'$Servicio','$Prefijo','$Cont_min','$Cont_max','$Secuencia','$Prioridad',
        '$LlamadoTv','$Eliminado','$EstadoSub','$atril','$VisibleDispe','$tiempoMax','$HoraInicio',
        '$HoraFin','$atencioncita','$entrega','$IdSede','$emp_id',1)");
        if ($validarNube) {
            hacerConsulta("UPDATE servicio SET EstadoNube = 1 WHERE IdServicio = $IdServicio AND IdSede = $IdSede 
            AND emp_id = $emp_id");
        }
    }
}

function sincronizarUsuarios()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayUsuarios = DevolverUnArreglo("SELECT * FROM usuario WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayUsuarios as $key) {
        $IdUsuario = $key['IdUsuario'];
        $Cedula = $key['Cedula'];
        $NombreCompleto = $key['NombreCompleto'];
        $Correo = $key['Correo'];
        $Telefono = $key['Telefono'];
        $Rol = $key['Rol'];
        $IdTipoRol = $key['IdTipoRol'];
        $Estado = $key['Estado'];
        $NombreUsuario = $key['NombreUsuario'];
        $Contrasena = $key['Contrasena'];
        $LlamadoTv = $key['LlamadoTv'];
        $EstadoRecuperarContra = $key['EstadoRecuperarContra'];
        $Eliminado = $key['Eliminado'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $registro = $key['registro'];
        $arrayUsuariosNube = DevolverUnArregloNube("SELECT * FROM usuario WHERE IdUsuario = $IdUsuario AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayUsuariosNube) {
            hacerConsultaNube("DELETE FROM usuario WHERE IdUsuario = $IdUsuario  and IdSede = $IdSede and emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO usuario 
        (IdUsuario,Cedula,NombreCompleto,Correo,Telefono,Rol,IdTipoRol,Estado,
        NombreUsuario,Contrasena,LlamadoTv,EstadoRecuperarContra,Eliminado,
        registro,IdSede,emp_id,EstadoNube) 
        values 
        ('$IdUsuario','$Cedula','$NombreCompleto','$Correo','$Telefono','$Rol','$IdTipoRol','$Estado',
        '$NombreUsuario','$Contrasena','$LlamadoTv','$EstadoRecuperarContra','$Eliminado',
        '$registro','$IdSede','$emp_id','1')");
        if ($validarNube) {
            hacerConsulta("UPDATE usuario SET EstadoNube = 1 WHERE IdUsuario = $IdUsuario AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarAuditoria()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayUsuarios = DevolverUnArreglo("SELECT * FROM auditoria WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayUsuarios as $key) {
        $IdAuditoria = $key['IdAuditoria'];
        $IdServicio = $key['IdServicio'];
        $IdUsuario = $key['IdUsuario'];
        $Turno = $key['Turno'];
        $IdPersona = $key['IdPersona'];
        $IdPersonaAtril = $key['IdPersonaAtril'];
        $IdEncuesta = $key['IdEncuesta'];
        $Estado = $key['Estado'];
        $FechaLlegada = $key['FechaLlegada'];
        $FechaLlamado = $key['FechaLlamado'];
        $Fechasalio = $key['Fechasalio'];
        $NumeroLlamados = $key['NumeroLlamados'];
        $Observacion = $key['Observacion'];
        $ObservacionAsesor = $key['ObservacionAsesor'];
        $ObservacionRetraso = $key['ObservacionRetraso'];
        $idrelacionservicio = $key['idrelacionservicio'];
        $FLlamadoDocGeneral = $key['FLlamadoDocGeneral'];
        $FSalioDocGeneral = $key['FSalioDocGeneral'];
        $ObservacionDoctorGeneral = $key['ObservacionDoctorGeneral'];
        $idDoctorGeneral = $key['idDoctorGeneral'];
        $IdTurnoAgendado = $key['IdTurnoAgendado'];
        $Eliminado = $key['Eliminado'];
        $nivel = $key['nivel'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $EstadoQR = $key['EstadoQR'];
        $arrayUsuariosNube = DevolverUnArregloNube("SELECT * FROM auditoria WHERE IdAuditoria = $IdAuditoria and IdSede = $IdSede and emp_id = $emp_id");
        if ($arrayUsuariosNube) {
            hacerConsultaNube("DELETE FROM auditoria WHERE IdAuditoria = $IdAuditoria AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        
        $validarNube = hacerConsultaNube("INSERT INTO auditoria 
        (IdAuditoria,IdServicio,IdUsuario,Turno,IdPersona,IdPersonaAtril,IdEncuesta,Estado,
        FechaLlegada,FechaLlamado,Fechasalio,NumeroLlamados,Observacion,ObservacionAsesor,
        ObservacionRetraso,EstadoNube,idrelacionservicio,FLlamadoDocGeneral,FSalioDocGeneral,
        ObservacionDoctorGeneral,idDoctorGeneral,IdTurnoAgendado,Eliminado,nivel,IdSede,
        emp_id,EstadoQR) VALUES 
        ('$IdAuditoria','$IdServicio','$IdUsuario','$Turno','$IdPersona','$IdPersonaAtril','$IdEncuesta','$Estado',
        '$FechaLlegada','$FechaLlamado','$Fechasalio','$NumeroLlamados','$Observacion','$ObservacionAsesor',
        '$ObservacionRetraso','1','$idrelacionservicio','$FLlamadoDocGeneral','$FSalioDocGeneral',
        '$ObservacionDoctorGeneral','$idDoctorGeneral','$IdTurnoAgendado','$Eliminado','$nivel','$IdSede',
        '$emp_id','$EstadoQR')");
        if ($validarNube) {
            hacerConsulta("UPDATE auditoria SET EstadoNube = 1 WHERE IdAuditoria = $IdAuditoria AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarCalificacion()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayCalificacion = DevolverUnArreglo("SELECT * FROM calificacion WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayCalificacion as $key) {
        $IdCalificacion = $key['IdCalificacion'];
        $NumCalif = $key['NumCalif'];
        $IdUsuario = $key['IdUsuario'];
        $FechaCalif = $key['FechaCalif'];
        $IdPregunta = $key['IdPregunta'];
        $IdAuditoria = $key['IdAuditoria'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayUsuariosNube = DevolverUnArregloNube("SELECT * FROM calificacion WHERE IdCalificacion = $IdCalificacion AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayUsuariosNube) {
            hacerConsultaNube("DELETE FROM calificacion WHERE IdCalificacion = $IdCalificacion AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO calificacion 
        (IdCalificacion,NumCalif,IdUsuario,FechaCalif,IdPregunta,IdAuditoria,IdSede,emp_id,EstadoNube) 
        VALUES 
        ('$IdCalificacion','$NumCalif','$IdUsuario','$FechaCalif','$IdPregunta','$IdAuditoria','$IdSede','$emp_id',1)");
        if ($validarNube) {
            hacerConsulta("UPDATE calificacion SET EstadoNube = 1 WHERE IdCalificacion = $IdCalificacion AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarRelacionUsuSer()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayRelacionUsuSer = DevolverUnArreglo("SELECT * FROM relacionususer WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayRelacionUsuSer as $key) {
        
        $IdRelacion = $key['IdRelacion'];
        $IdServicio = $key['IdServicio'];
        $IdUsuario = $key['IdUsuario'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayRelacionNube = DevolverUnArregloNube("SELECT * FROM relacionususer WHERE IdRelacion = $IdRelacion AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelacionNube) {
            hacerConsultaNube("DELETE FROM relacionususer WHERE IdRelacion = $IdRelacion AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO relacionususer 
        (IdRelacion,IdServicio,IdUsuario,IdSede,emp_id,Eliminado,EstadoNube) 
        VALUES 
        ($IdRelacion,$IdServicio,$IdUsuario,$IdSede,$emp_id,$Eliminado,1)");
        if ($validarNube) {
            hacerConsulta("UPDATE relacionususer SET EstadoNube = 1 WHERE IdRelacion = $IdRelacion AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarpreguntas()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arraypreguntas = DevolverUnArreglo("SELECT * FROM preguntas WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arraypreguntas as $key) {
        $IdPregunta = $key['IdPregunta'];
        $Pregunta = $key['Pregunta'];
        $Eliminado = $key['Eliminado'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayRelacionNube = DevolverUnArregloNube("SELECT * FROM preguntas WHERE IdPregunta = $IdPregunta AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelacionNube) {
            hacerConsultaNube("DELETE FROM preguntas WHERE IdPregunta = $IdPregunta AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        hacerConsulta("UPDATE preguntas SET EstadoNube = 1 WHERE IdPregunta = $IdPregunta AND IdSede = $IdSede AND emp_id = $emp_id");
        hacerConsultaNube("INSERT INTO preguntas 
        (IdPregunta,Pregunta,Eliminado,IdSede,emp_id,EstadoNube) 
        VALUES ($IdPregunta,'$Pregunta',$Eliminado,$IdSede,$emp_id,1)");
    }
}

function sincronizarModulo()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayModulo = DevolverUnArreglo("SELECT * FROM modulo WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayModulo as $key) {
        $Id = $key['Id'];
        $IdModulo = $key['IdModulo'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayModuloNube = DevolverUnArregloNube("SELECT * FROM modulo WHERE Id = $Id AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayModuloNube) {
            hacerConsultaNube("DELETE FROM modulo WHERE Id = $Id AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO modulo (Id,IdModulo,IdSede,emp_id,Eliminado,EstadoNube) 
        VALUES ('$Id','$IdModulo','$IdSede','$emp_id','$Eliminado',1)");
        if ($validarNube) {
        hacerConsulta("UPDATE modulo SET EstadoNube = 1 WHERE Id = $Id and IdSede = $IdSede and emp_id = $emp_id");
        }
    }
}

function sincronizarPacientes()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayPacientes = DevolverUnArreglo("SELECT * FROM personas WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayPacientes as $key) {
        $IdPersona = $key['IdPersona'];
        $NombreCompleto = $key['NombreCompleto'];
        $Cedula = $key['Cedula'];
        $Sexo = $key['Sexo'];
        $Direccion = $key['Direccion'];
        $Barrio = $key['Barrio'];
        $Telefono = $key['Telefono'];
        $FechaNacimiento = $key['FechaNacimiento'];
        $eps = $key['eps'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];

        $arrayPacientesNube = DevolverUnArregloNube("SELECT * FROM personas WHERE IdPersona = $IdPersona AND 
        IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayPacientesNube) {
            hacerConsultaNube("DELETE FROM personas WHERE IdPersona = $IdPersona AND IdSede = $IdSede AND 
            emp_id = $emp_id");
        }
        
        $validarNube = hacerConsultaNube("INSERT INTO personas (IdPersona,NombreCompleto,Cedula,Sexo,Direccion,
        Barrio,Telefono,FechaNacimiento,eps,IdSede,emp_id,Eliminado,EstadoNube) values ('$IdPersona',
        '$NombreCompleto','$Cedula','$Sexo','$Direccion','$Barrio','$Telefono','$FechaNacimiento','$eps',
        '$IdSede','$emp_id','$Eliminado',1)");
        if ($validarNube) {
            hacerConsulta("UPDATE personas SET EstadoNube = 1 WHERE IdPersona = $IdPersona AND IdSede = 
            $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarRelaServicios()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayRelaServicios = DevolverUnArreglo("SELECT * FROM relacionservicios WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayRelaServicios as $key) {
        $idrelacionservicio = $key['idrelacionservicio'];
        $servicio = $key['servicio'];
        $subservicio = $key['subservicio'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Asignado = $key['Asignado'];
        $Eliminado = $key['Eliminado'];
        $arrayRelaServiciosNube = DevolverUnArregloNube("SELECT * FROM relacionservicios WHERE idrelacionservicio = $idrelacionservicio AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelaServiciosNube) {
            hacerConsultaNube("DELETE FROM relacionservicios WHERE idrelacionservicio = $idrelacionservicio AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO relacionservicios 
        (idrelacionservicio,servicio,subservicio,IdSede,emp_id,Asignado,EstadoNube,Eliminado) 
        values 
        ('$idrelacionservicio','$servicio','$subservicio','$IdSede','$emp_id','$Asignado','1','$Eliminado')");
        if ($validarNube) {
            hacerConsulta("UPDATE relacionservicios SET EstadoNube = 1 WHERE idrelacionservicio  = $idrelacionservicio AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarEspecialidad()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayEspecialidad = DevolverUnArreglo("SELECT * FROM especialidad WHERE EstadoNube = 0 AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
    foreach ($arrayEspecialidad as $key) {
        $IdTipoRol = $key['IdTipoRol'];
        $NombreRol = $key['NombreRol'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayEspecialidadNube = DevolverUnArregloNube("SELECT * FROM especialidad WHERE IdTipoRol = $IdTipoRol AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayEspecialidadNube) {
            hacerConsultaNube("DELETE FROM especialidad WHERE IdTipoRol = $IdTipoRol AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validarNube = hacerConsultaNube("INSERT INTO especialidad 
        (IdTipoRol,NombreRol,Eliminado,IdSede,emp_id,EstadoNube) VALUES ($IdTipoRol,'$NombreRol',$Eliminado,$IdSede,$emp_id,1)");
        if ($validarNube) {
            hacerConsulta("UPDATE especialidad SET EstadoNube = 1 WHERE IdTipoRol = $IdTipoRol AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

// function sincronizarHorariosAgenda()
// {
//     $arrayHorarios = DevolverUnArreglo("select * from horarioagenda where EstadoNube = 0");
//     if (count($arrayHorarios) != 0) {
//         global $empresaIdGlobal;
//         global $sedeIdGlobal;
//         hacerConsultaNube("Delete from horarioagenda where IdSede = $sedeIdGlobal and emp_id = $empresaIdGlobal");
//         $fecha = DevolverUnDatoNube("SELECT NOW()");
//         foreach ($arrayHorarios as $key) {
//             $IdHorarioAgenda = $key['IdHorarioAgenda'];
//             $HoraAgenda = $key['HoraAgenda'];
//             $IdSede = $key['IdSede'];
//             $emp_id = $key['emp_id'];
//             $Estado = $key['Estado'];
//             $Eliminado = $key['Eliminado'];
//             $validarConsulta = hacerConsultaNube("INSERT INTO horarioagenda(IdHorarioAgenda, HoraAgenda, IdSede, emp_id, Estado, Fecha, EstadoNube, Eliminado) VALUES ($IdHorarioAgenda,'$HoraAgenda',$IdSede,$emp_id,'$Estado','$fecha',1,$Eliminado)");
//             if ($validarConsulta) {
//                 hacerConsulta("UPDATE horarioagenda SET EstadoNube = 1 WHERE IdSede = $IdSede AND emp_id = $emp_id AND IdHorarioAgenda = $IdHorarioAgenda");
//             }
//         }
//     }
// }

function sincronizarHorariosAgenda()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayHorarios = DevolverUnArreglo("SELECT * FROM horarioagenda WHERE EstadoNube = 0 AND IdSede = '$sedeIdGlobal' AND emp_id = '$empresaIdGlobal'");
    $arrayDias = DevolverUnArreglo("SELECT * FROM diahorarioagenda WHERE EstadoNube = 0 AND IdSede = '$sedeIdGlobal' AND emp_id = '$empresaIdGlobal'");
    if (count($arrayDias) != 0) {
        for ($i=0; $i < COUNT($arrayDias); $i++) { 
            if($arrayDias[$i]['EstadoNube'] == 0){
                hacerConsultaNube("DELETE FROM diahorarioagenda WHERE id_dia = '".$arrayDias[$i]['id_dia']."' AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
                hacerConsultaNube("INSERT INTO diahorarioagenda (id_dia,nombre,habilitado,EstadoNube,emp_id,IdSede) VALUES ('".$arrayDias[$i]['id_dia']."','".$arrayDias[$i]['nombre']."','".$arrayDias[$i]['habilitado']."','".$arrayDias[$i]['EstadoNube']."','".$arrayDias[$i]['emp_id']."','".$arrayDias[$i]['IdSede']."')");
                hacerConsulta("UPDATE diahorarioagenda SET EstadoNube= 1 WHERE id_dia = '".$arrayDias[$i]['id_dia']."' AND IdSede = '$sedeIdGlobal' AND emp_id = '$empresaIdGlobal'");
            }
        }
    }

    if (count($arrayHorarios) != 0) {
        $DiaGuardado = 0;
        $fecha = DevolverUnDatoNube("SELECT NOW()");
        foreach ($arrayHorarios as $key) {
            $IdHorarioAgenda = $key['IdHorarioAgenda'];
            $HoraAgenda = $key['HoraAgenda'];
            $idDia = $key['id_dia'];
            $IdSede = $key['IdSede'];
            $emp_id = $key['emp_id'];
            $Estado = $key['Estado'];
            $Eliminado = $key['Eliminado'];
            //
            if($DiaGuardado != $idDia){
                $DiaGuardado = $idDia;
                hacerConsultaNube("DELETE FROM horarioagenda WHERE id_dia = '$idDia' AND IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
            }
            $validarConsulta = hacerConsultaNube("INSERT INTO horarioagenda (IdHorarioAgenda,id_dia,HoraAgenda, IdSede, emp_id, Estado, EstadoNube, Eliminado) VALUES ($IdHorarioAgenda,$idDia,'$HoraAgenda',$IdSede,$emp_id,'$Estado',1,$Eliminado)");
            if ($validarConsulta) {
                hacerConsulta("UPDATE horarioagenda SET EstadoNube = 1 WHERE IdSede = $IdSede AND emp_id = $emp_id AND IdHorarioAgenda = $IdHorarioAgenda");
            }
        }
    }
}


//Sincronizar de la nube a local
function sincronizarServiciosNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayServicios = DevolverUnArregloNube("SELECT * FROM servicio WHERE EstadoNube = 0 AND (IdSede = $empresaIdGlobal and emp_id = $sedeIdGlobal)");
    foreach ($arrayServicios as $key) {
        $IdServicio = $key['IdServicio'];
        $Servicio = $key['Servicio'];
        $Prefijo = $key['Prefijo'];
        $Cont_min = $key['Cont_min'];
        $Cont_max = $key['Cont_max'];
        $Secuencia = $key['Secuencia'];
        $Prioridad = $key['Prioridad'];
        $LlamadoTv = $key['LlamadoTv'];
        $Eliminado = $key['Eliminado'];
        $EstadoSub = $key['EstadoSub'];
        $atril = $key['atril'];
        $VisibleDispe = $key['VisibleDispe'];
        $tiempoMax = $key['tiempoMax'];
        $HoraInicio = $key['HoraInicio'];
        $HoraFin = $key['HoraFin'];
        $atencioncita = $key['atencioncita'];
        $entrega = $key['entrega'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayServicios = DevolverUnArreglo("SELECT * FROM servicio where IdServicio = $IdServicio AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayServicios) {
            hacerConsulta("DELETE FROM servicio WHERE IdServicio = $IdServicio AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO servicio (IdServicio,Servicio,Prefijo,Cont_min,Cont_max,Secuencia,
        Prioridad,LlamadoTv,Eliminado,EstadoSub,atril,VisibleDispe,tiempoMax,HoraInicio,HoraFin,atencioncita,entrega,
        IdSede,emp_id,EstadoNube) VALUES ('$IdServicio','$Servicio','$Prefijo','$Cont_min','$Cont_max',
        '$Secuencia','$Prioridad','$LlamadoTv','$Eliminado','$EstadoSub','$atril','$VisibleDispe','$tiempoMax',
        '$HoraInicio','$HoraFin','$atencioncita','$entrega','$IdSede','$emp_id',1)");
        if ($validar) {
            hacerConsultaNube("UPDATE servicio SET EstadoNube = 1 WHERE IdServicio = $IdServicio AND IdSede = $IdSede 
            AND emp_id = $emp_id");
        }
    }
}

function sincronizarUsuariosNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayUsuarios = DevolverUnArregloNube("SELECT * FROM usuario WHERE EstadoNube = 0 AND (IdSede =  $empresaIdGlobal AND emp_id = $sedeIdGlobal)");
    foreach ($arrayUsuarios as $key) {

        $IdUsuario = $key['IdUsuario'];
        $Cedula = $key['Cedula'];
        $NombreCompleto = $key['NombreCompleto'];
        $Correo = $key['Correo'];
        $Telefono = $key['Telefono'];
        $Rol = $key['Rol'];
        $IdTipoRol = $key['IdTipoRol'];
        $Estado = $key['Estado'];
        $NombreUsuario = $key['NombreUsuario'];
        $Contrasena = $key['Contrasena'];
        $LlamadoTv = $key['LlamadoTv'];
        $EstadoRecuperarContra = $key['EstadoRecuperarContra'];
        $Eliminado = $key['Eliminado'];
        $registro = $key['registro'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayUsuarios = DevolverUnArreglo("SELECT * FROM usuario WHERE IdUsuario = $IdUsuario AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayUsuarios) {
            hacerConsulta("DELETE FROM usuario WHERE IdUsuario = $IdUsuario AND IdSede = $IdSede AND emp_id = $emp_id");
        }
      
        $validar = hacerConsulta("INSERT INTO usuario (IdUsuario,Cedula,NombreCompleto,Correo,Telefono,Rol,IdTipoRol,
        Estado,NombreUsuario,Contrasena,LlamadoTv,EstadoRecuperarContra,Eliminado,registro,IdSede,emp_id,EstadoNube) 
        values ('$IdUsuario','$Cedula','$NombreCompleto','$Correo','$Telefono','$Rol','$IdTipoRol','$Estado',
        '$NombreUsuario','$Contrasena','$LlamadoTv','$EstadoRecuperarContra','$Eliminado','$registro','$IdSede','$emp_id',1)");
        if ($Rol == 'ASESOR') {
            $idServicioCitaSinTurno = DevolverUnDato("SELECT IdServicio FROM servicio WHERE Servicio = 'CITA SIN TURNO'");
            hacerConsulta("INSERT INTO relacionususer (IdServicio,IdUsuario,IdSede,emp_id,EstadoNube,Eliminado) 
            VALUES ($idServicioCitaSinTurno,$IdUsuario,$IdSede,$emp_id,1,0) ");
        }
        if ($validar) {
            hacerConsultaNube("UPDATE usuario SET EstadoNube = 1 WHERE IdUsuario = $IdUsuario AND IdSede = $IdSede 
            AND emp_id = $emp_id");
        }
    }
}

function sincronizarModuloNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayModulo = DevolverUnArregloNube("select * from modulo where EstadoNube = 0 and (IdSede =  $empresaIdGlobal and emp_id = $sedeIdGlobal)");
   
    foreach ($arrayModulo as $key) {
        $Id = $key['Id'];
        $IdModulo = $key['IdModulo'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayModulo = DevolverUnArreglo("select * from modulo where Id = $Id and IdSede = $IdSede and emp_id = $emp_id");
        if ($arrayModulo) {
            hacerConsulta("Delete from modulo where Id = $Id and IdSede = $IdSede and emp_id = $emp_id");
        }
        $validar = hacerConsulta("insert into modulo (Id,IdModulo,IdSede,emp_id,Eliminado,EstadoNube)"
            . "values ($Id,$IdModulo,$IdSede,$emp_id,$Eliminado,1)");
        if ($validar) {
            hacerConsultaNube("update modulo set EstadoNube = 1 where Id = $Id and IdSede = $IdSede and emp_id = $emp_id");
        }
    }
}

function sincronizarpreguntasNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arraypreguntas = DevolverUnArregloNube("SELECT * FROM preguntas WHERE EstadoNube = 0 AND 
    (IdSede = $empresaIdGlobal AND emp_id = $sedeIdGlobal)");
    foreach ($arraypreguntas as $key) {
        $IdPregunta = $key['IdPregunta'];
        $Pregunta = $key['Pregunta'];
        $Eliminado = $key['Eliminado'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $arrayRelacion = DevolverUnArreglo("SELECT * FROM preguntas WHERE IdPregunta = $IdPregunta 
        AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelacion) {
            hacerConsulta("DELETE FROM preguntas WHERE IdPregunta = $IdPregunta AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO preguntas (IdPregunta,Pregunta,Eliminado,IdSede,emp_id,EstadoNube) 
        VALUES ($IdPregunta,'$Pregunta','$Eliminado',$IdSede,$emp_id,1)");
        if ($validar) {
            hacerConsultaNube("UPDATE preguntas SET EstadoNube = 1 WHERE IdPregunta = $IdPregunta AND 
            IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarRelacionUsuSerNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayRelacionUsuSer = DevolverUnArregloNube("SELECT * FROM relacionususer WHERE EstadoNube = 0 AND 
    (IdSede = $empresaIdGlobal AND emp_id = $sedeIdGlobal)");
    foreach ($arrayRelacionUsuSer as $key) {
        $IdRelacion = $key['IdRelacion'];
        $IdServicio = $key['IdServicio'];
        $IdUsuario = $key['IdUsuario'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayRelacion = DevolverUnArreglo("SELECT * FROM relacionususer WHERE IdRelacion = $IdRelacion AND 
        IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelacion) {
            hacerConsulta("DELETE FROM relacionususer WHERE IdRelacion = $IdRelacion AND IdSede = $IdSede AND 
            emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO relacionususer (IdRelacion,IdServicio,IdUsuario,IdSede,emp_id,
        EstadoNube,Eliminado) VALUES ($IdRelacion,$IdServicio,$IdUsuario,$IdSede,$emp_id,1,$Eliminado)");
        if ($validar) {
            hacerConsultaNube("UPDATE relacionususer SET EstadoNube = 1 WHERE IdRelacion = $IdRelacion AND 
            IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarPacientesNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayPacientes = DevolverUnArregloNube("SELECT * FROM personas WHERE EstadoNube = 0 AND 
    (IdSede = $empresaIdGlobal AND emp_id = $sedeIdGlobal)");
    foreach ($arrayPacientes as $key) {
        $IdPersona = $key['IdPersona'];
        $NombreCompleto = $key['NombreCompleto'];
        $Cedula = $key['Cedula'];
        $Sexo = $key['Sexo'];
        $Direccion = $key['Direccion'];
        $Barrio = $key['Barrio'];
        $Telefono = $key['Telefono'];
        $FechaNacimiento = $key['FechaNacimiento'];
        $eps = $key['eps'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayPacientes = DevolverUnArreglo("SELECT * FROM personas WHERE IdPersona = $IdPersona AND 
        IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayPacientes) {
            hacerConsulta("DELETE FROM personas WHERE IdPersona = $IdPersona AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO personas (IdPersona,NombreCompleto,Cedula,Sexo,Direccion,Barrio,
            Telefono,FechaNacimiento,eps,IdSede,emp_id,EstadoNube,Eliminado) values ('$IdPersona','$NombreCompleto',
            '$Cedula','$Sexo','$Direccion','$Barrio','$Telefono','$FechaNacimiento','$eps',$IdSede,$emp_id,1,$Eliminado)");
        if ($validar) {
            hacerConsultaNube("UPDATE personas SET EstadoNube = 1 WHERE IdPersona = $IdPersona AND 
            IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarEspecialidadNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayEspecialidad = DevolverUnArregloNube("SELECT * FROM especialidad WHERE EstadoNube = 0 AND 
    (IdSede = $empresaIdGlobal AND emp_id = $sedeIdGlobal)");
    foreach ($arrayEspecialidad as $key) {
        $IdTipoRol = $key['IdTipoRol'];
        $NombreRol = $key['NombreRol'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Eliminado = $key['Eliminado'];
        $arrayEspecialidad = DevolverUnArreglo("SELECT * FROM especialidad WHERE IdTipoRol = $IdTipoRol AND 
        IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayEspecialidad) {
            hacerConsulta("DELETE FROM especialidad WHERE IdTipoRol = $IdTipoRol AND IdSede = $IdSede AND 
            emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO especialidad (IdTipoRol,NombreRol,Eliminado,IdSede,emp_id,EstadoNube) 
        VALUES ('$IdTipoRol','$NombreRol','$Eliminado','$IdSede','$emp_id',1)");
        if ($validar) {
            hacerConsultaNube("UPDATE especialidad SET EstadoNube = 1 WHERE IdTipoRol = $IdTipoRol AND 
            IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarRelaServiciosNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayRelaServicios = DevolverUnArregloNube("SELECT * FROM relacionservicios WHERE EstadoNube = 0 AND 
    (IdSede = $empresaIdGlobal and emp_id = $sedeIdGlobal)");
    foreach ($arrayRelaServicios as $key) {
        $idrelacionservicio = $key['idrelacionservicio'];
        $servicio = $key['servicio'];
        $subservicio = $key['subservicio'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        $Asignado = $key['Asignado'];
        $Asignado = $key['Eliminado'];
        $arrayRelaServicios = DevolverUnArreglo("SELECT * FROM relacionservicios WHERE 
        idrelacionservicio = $idrelacionservicio AND IdSede = $IdSede AND emp_id = $emp_id");
        if ($arrayRelaServicios) {
            hacerConsulta("DELETE FROM relacionservicios WHERE idrelacionservicio = $idrelacionservicio 
            AND IdSede = $IdSede AND emp_id = $emp_id");
        }
        $validar = hacerConsulta("INSERT INTO relacionservicios (idrelacionservicio,servicio,subservicio,
        IdSede,emp_id,EstadoNube,Asignado,Eliminado) values ('$idrelacionservicio','$servicio','$subservicio',
        '$IdSede','$emp_id','1','$Asignado',1)");
        if ($validar) {
            hacerConsultaNube("UPDATE relacionservicios SET EstadoNube = 1 WHERE 
            idrelacionservicio = $idrelacionservicio AND IdSede = $IdSede AND emp_id = $emp_id");
        }
    }
}

function sincronizarHorarioAgendaNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayHorarios = DevolverUnArregloNube("SELECT * FROM horarioagenda WHERE IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal AND EstadoNube = 0");
    $arrayHorariosFecha = DevolverUnArregloNube("SELECT * FROM horarioagenda WHERE IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal AND EstadoNube = 0 LIMIT 1");
    $fecha = DevolverUnDatoNube("SELECT NOW()");
    if (count($arrayHorariosFecha) != 0) {
        $fechaRegistro = $arrayHorariosFecha[0]['Fecha'];
        if ($fechaRegistro < $fecha) {
            hacerConsultaNube("UPDATE horarioagenda SET Estado = 0, Fecha = '$fecha'");
        }
    }
    if (count($arrayHorarios) != 0) {
        hacerConsulta("Delete from horarioagenda where IdSede = $sedeIdGlobal and emp_id = $empresaIdGlobal");
        foreach ($arrayHorarios as $key) {
            $IdHorarioAgenda = $key['IdHorarioAgenda'];
            $HoraAgenda = $key['HoraAgenda'];
            $IdSede = $key['IdSede'];
            $emp_id = $key['emp_id'];
            $Estado = $key['Estado'];
            $Eliminado = $key['Eliminado'];
            $validarConsulta = hacerConsulta("INSERT INTO horarioagenda(IdHorarioAgenda, HoraAgenda, IdSede, emp_id, Estado, EstadoNube, Eliminado) VALUES ($IdHorarioAgenda,'$HoraAgenda',$IdSede,$emp_id,'$Estado',1,$Eliminado)");
            if ($validarConsulta) {
                hacerConsultaNube("UPDATE horarioagenda SET EstadoNube=1 WHERE IdSede = $IdSede AND emp_id = $emp_id AND IdHorarioAgenda = $IdHorarioAgenda");
            }
        }
    }
}

function sincronizarTurnoAgendadoNube()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $fecha = DevolverUnDatoNube("SELECT DATE_SUB(NOW(),INTERVAL 5 MINUTE)");
    $fecha2 = DevolverUnDatoNube("SELECT DATE_ADD(NOW(),INTERVAL 5 MINUTE)");
    $arrayRelaServicios = DevolverUnArregloNube("SELECT * FROM turnoagendado where EstadoNube = 0 AND 
    (FechaLlegada >= '$fecha' AND FechaLlegada <= '$fecha2' ) AND (IdSede =  $sedeIdGlobal AND emp_id = 
    $empresaIdGlobal)");
    foreach ($arrayRelaServicios as $key) {
        $IdTurnoAgendado = $key['IdTurnoAgendado'];
        $IdServicio = $key['IdServicio'];
        $Turno = $key['Turno'];
        $Cedula = $key['Cedula'];
        $FechaLlegada = $key['FechaLlegada'];
        $idrelacionservicio = $key['idrelacionservicio'];
        $Eliminado = $key['Eliminado'];
        $IdSede = $key['IdSede'];
        $emp_id = $key['emp_id'];
        if ($Eliminado) {
            $validar1 = hacerConsulta("UPDATE auditoria SET Eliminado = 1 WHERE IdTurnoAgendado = $IdTurnoAgendado");
            $validar2 = hacerConsulta("DELETE FROM tablatemporal WHERE IdTurnoAgendado = $IdTurnoAgendado");
            if ($validar1 && $validar2) {
                hacerConsultaNube("UPDATE turnoagendado SET EstadoNube = 1 where IdTurnoAgendado = $IdTurnoAgendado AND 
                (IdSede = $IdSede AND emp_id = $emp_id)");
            }
        } else {
            $idpersona = DevolverUnDato("SELECT IdPersona FROM personas WHERE Cedula = '$Cedula'");
            $IdAuditoria = InsertDevolviendoID("INSERT INTO auditoria 
            (IdServicio,IdUsuario,Turno,IdPersona,IdPersonaAtril,IdEncuesta,Estado,FechaLlegada,FechaLlamado,
            Fechasalio,NumeroLlamados,Observacion,ObservacionAsesor,ObservacionRetraso,EstadoNube,idrelacionservicio,
            FLlamadoDocGeneral,FSalioDocGeneral,ObservacionDoctorGeneral,idDoctorGeneral,IdTurnoAgendado,Eliminado,
            nivel,IdSede,emp_id,EstadoQR) 
            VALUES ($IdServicio,'0','$Turno','$idpersona','0','0','NORMAL','$FechaLlegada','0000-00-00 00:00:00',
            '0000-00-00 00:00:00','0','','','','0',$idrelacionservicio,
            '0000-00-00 00:00:00','0000-00-00 00:00:00','','0',$IdTurnoAgendado,'0',
            '',$IdSede,$emp_id,'0')");
            $validar = hacerConsulta("INSERT INTO tablatemporal 
            (IdServicio,Turno,Estado,Dato1,Dato2,LlamadoPor,Prioridad,FechaLlegada,IdAuditoria,Observacion,
            FechaLlamado,UltimoLlamado,EstadoLlamado,transferenciaUsuario,IdCita,EstadoPrioridadDoctor,
            NombrePaciente,CedulaPersona,IdPersona,EstadoNube,tienecita,IdTurnoAgendado,IdSede,emp_id) 
            VALUES ($IdServicio,'$Turno','NORMAL','','$Cedula','ASESOR',2,'$FechaLlegada',$IdAuditoria,'',
            '0000-00-00 00:00:00','0','0','0','0','',
            '','','$idpersona','0','0',$IdTurnoAgendado,$IdSede,$emp_id)");
            if ($IdAuditoria && $validar) {
                hacerConsultaNube("UPDATE turnoagendado SET EstadoNube = 1 WHERE IdTurnoAgendado = $IdTurnoAgendado 
                AND (IdSede = $IdSede AND emp_id = $emp_id)");
            }
        }
    }
}

function sincronizarTvs()
{
    global $empresaIdGlobal;
    global $sedeIdGlobal;
    $arrayTvs = DevolverUnArreglo("SELECT * FROM configtv WHERE EstadoNube = 0 AND IdSede = '$sedeIdGlobal' AND emp_id = '$empresaIdGlobal'");
    if (count($arrayTvs) != 0) {
        hacerConsultaNube("DELETE FROM configtv WHERE IdSede = $sedeIdGlobal AND emp_id = $empresaIdGlobal");
        $fecha = DevolverUnDatoNube("SELECT NOW()");
        foreach ($arrayTvs as $key) {
            $id = $key['id'];
            $mensaje = $key['mensaje'];
            $TamanoLetra = $key['TamanoLetra'];
            $nombreLogo = $key['nombreLogo'];
            $estado = $key['estado'];
            $CambioTv = $key['CambioTv'];
            $VolumenVoz = $key['VolumenVoz'];
            $IpVisualizador = $key['IpVisualizador'];
            $TipoVisualizador = $key['TipoVisualizador'];
            $TvCode = $key['TvCode'];
            $IdSede = $key['IdSede'];
            $emp_id = $key['emp_id'];
            
            $validarConsulta = hacerConsultaNube("INSERT INTO configtv 
            (id,mensaje,TamanoLetra,nombreLogo,estado,CambioTv,VolumenVoz,IpVisualizador,
            TipoVisualizador,TvCode,IdSede,emp_id,EstadoNube) 
            VALUES 
            ($id,'$mensaje','$TamanoLetra','$nombreLogo','$estado','$CambioTv','$VolumenVoz',
            '$IpVisualizador','$TipoVisualizador','$TvCode','$IdSede','$emp_id','1')");
            if ($validarConsulta) {
                hacerConsulta("UPDATE configtv SET EstadoNube = 1 WHERE IdSede = $IdSede AND emp_id = $emp_id AND id = $id");
            }
        }
    }
}